#include "cdreader.h"

//  open.c
//  open, close, init, shutdown functions


// opens a dialog box and gets a file
// new file types need to be added here and in the newCD function
int CDopen(void)
{
#ifdef _WINDOWS
	 OPENFILENAME	  ofn;

	 char 	 szFileTitle[_MAX_FNAME + _MAX_EXT], 
							szFile[_MAX_PATH];

    // add new file types here!!
    char 	 szFilter[] = "All files (*.*)\0*.*\0" \
                          "Rar file (*.rar)\0*.rar\0" \
                          "Cue file (*.cue)\0*.cue\0" \
								  "Bin file (*.bin)\0*.bin\0" \
                          "Iso file (*.iso)\0*.iso\0" \
                          "Img file (*.img)\0*.img\0" \
                          "Indexed Bzip file (*.bz)\0*.bz\0" \
                          "Bzip index file (*.bz.index)\0*.bz.index\0" \
                          "Z file with table (*.Z)\0*.Z\0" \
                          "Z table file (*.Z.table)\0*.Z.table\0" \
                          "\0";

    char   currentDir[_MAX_PATH];
   _getcwd( currentDir, _MAX_PATH );
      
	szFile[0] = '\0';
	memset(&ofn, 0, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);

      // fpse needs this handle or else the open dialog won't stay open
   if (g != NULL)
   {
	   ofn.hwndOwner = g->HWnd;
   }
   else
   {
	   ofn.hwndOwner = NULL;
   }
   ofn.lpstrTitle = "Choose an image to open\0";
	ofn.lpstrFilter = szFilter;
	ofn.lpstrFile = szFile;
	ofn.nMaxFile = _MAX_PATH;
	ofn.lpstrFileTitle = szFileTitle;
	ofn.nMaxFileTitle = _MAX_FNAME + _MAX_EXT;
	ofn.lpstrInitialDir = NULL;	  /* use current directory */
	ofn.lpstrDefExt = NULL;		  /* default file extension */
										  
	GetOpenFileName(&ofn);
	lstrcat(szFile,"\0");	/* make sure it's null terminated */
   
   if (szFile[0] == '\0')
   {
#ifdef MOOBY_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log, "toast %s\n",szFile);
   fclose(log);
#endif

      rc = MessageBox(NULL,"No file selected.\nPush Retry to choose another file.\nPush Cancel to exit the emulator.","CDRMooby Exiting",MB_RETRYCANCEL|MB_SETFOREGROUND);

      while (rc == IDRETRY)
      {
      	GetOpenFileName(&ofn);
	      lstrcat(szFile,"\0");	/* make sure it's null terminated */
         if (szFile[0] == '\0')
         {
            rc = MessageBox(NULL,"No file selected.\nPush Retry to choose another file.\nPush Cancel to exit the emulator.","CDRMooby Exiting",MB_RETRYCANCEL|MB_SETFOREGROUND);
         }

      }
      if (rc == IDCANCEL)
      {
         exit(0);
      }
   }

#ifdef MOOBY_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log, "file %s\n",szFile);
   fclose(log);
#endif

	newCD(szFile);
#endif // _WINDOWS

   _chdir(currentDir);
	return 0;
}

// fpse open call - calls CDopen()
int  CD_Open(UINT32 *par) 
{
   g = (FPSEWin32*)par;

#ifdef MOOBY_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log,"\nopen fpsemode\n");
   fclose(log);
#endif
   return CDopen();
}

// psemu open call - call open
long CALLBACK CDRopen(void)
{
   g = NULL;
#ifdef MOOBY_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log, "\nopen psemumode\n");
   fclose(log);
#endif
	 return CDopen();
}

void CDclose(void)
{
#ifdef MOOBY_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log, "\nclose\n");
   fclose(log);
#endif
   CDDAclose();
   if (CD.cdda)
      fclose(CD.cdda);
   if (CD.cd)
      fclose(CD.cd);
   free(CD.tl);
   if (CD.fullBuffer)
      free(CD.fullBuffer);
}

// psemu close - whatever...
void  CD_Close(void) 
{
#ifdef MOOBY_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log, "\nCDclose\n");
   fclose(log);
#endif

   CDclose();
   return;
}

// fpse close
long CALLBACK CDRclose(void)
{
#ifdef MOOBY_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log, "\nCDRclose\n");
   fclose(log);
#endif

   CDclose();
   return 0;
}

long CALLBACK CDRinit(void)
{
#ifdef MOOBY_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log, "\ninit\n");
   fclose(log);
#endif

	return 0;
}

long CALLBACK CDRshutdown(void)
{
#ifdef MOOBY_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log, "\nCDRshutdown\n");
   fclose(log);
#endif

   CDclose();
	return 0;
}