#include "cdreader.h"

//  read.c
//  reading functions


// psemu callback - do bcd conversion on time request
long CALLBACK CDRreadTrack(unsigned char *time)
{
#ifdef SUPER_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log, "readtrack %02d:%02d:%02d\n", (int)BCDToInt(time[0]), 
      (int)BCDToInt(time[1]),
      (int)BCDToInt(time[2]));
   fclose(log);
#endif
   seekSector(BCDToInt(time[0]), 
      BCDToInt(time[1]),
      BCDToInt(time[2]));
	return 0;
}

// return the buffer - actually just gives it a pointer to
// the cache location, but who cares
unsigned char * CALLBACK CDRgetBuffer(void)
{
#ifdef SUPER_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log, "get\n");
   fclose(log);
#endif 
   return getSector();
}

// fpse read does both seek and get (1 call instead of psemu's 2).
// Also, FPSE does NOT bcd encode the time requests (took me a while
// to figure that out).
unsigned char * CD_Read(unsigned char *param)
{
#ifdef SUPER_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log, "read %02d:%02d:%02d\n", (int)param[0], 
      (int)param[1],
      (int)param[2]);
   fclose(log);
#endif

	seekSector(param[0], param[1], param[2]);
	return getSector();
}

// fpse wait - i donno what i'm really supposed to do here, so i just
// return ok.
int CD_Wait(void) 
{
#ifdef SUPER_DEBUG
   log = fopen(LOGFILE,"a");
   fprintf(log, "wait\n");
   fclose(log);
#endif

   return FPSE_OK;
};
